// Generated by CoffeeScript 1.6.3
/*
# jCounter - a simple character counter
#
# @author	Maximilian Mader
# @copyright	2011 - 2013 Maximilian Mader
# @license	BSD 3-Clause License <http://opensource.org/licenses/BSD-3-Clause>
# @package	be.bastelstu.max.wcf.jCounter
*/

(function($) {
  var jCounterID, throttle;
  jCounterID = 0;
  /*
  	# Throttle function <http://remysharp.com/2010/07/21/throttling-function-calls/>
  */

  throttle = function(fn, threshold, scope) {
    var deferTimer, last,
      _this = this;
    threshold || (threshold = 250);
    last = 0;
    deferTimer = null;
    return function() {
      var args, context, now;
      context = scope || _this;
      now = +(new Date);
      args = arguments;
      if (last && now < last + threshold) {
        clearTimeout(deferTimer);
        return deferTimer = setTimeout(function() {
          last = now;
          return fn.apply(context, args);
        }, threshold);
      } else {
        last = now;
        return fn.apply(context, args);
      }
    };
  };
  return $.fn.jCounter = function(container, options) {
    var firstStep, id, jCounter, step, _ref, _ref1,
      _this = this;
    if (this.length > 1) {
      return this.each(function(k, v) {
        return $(v).jCounter(container, options);
      });
    }
    if (!this.is('textarea, input:not([type=radio], [type=checkbox], [type=hidden], [type=color], [type=number], [type=range], [type=datetime], [type=date], [type=datetime-local], [type=month], [type=time], [type=week])')) {
      console.log('[jCounter] Unsupported element ' + (this.prop('tagName') === 'INPUT' ? "INPUT type='" + (this.attr('type')) + "'" : "type " + (this.prop('tagName'))));
      return this;
    }
    if (this.parent().hasClass('jCounterContainer')) {
      return this;
    }
    options = $.extend({
      max: 0,
      countUp: false
    }, options);
    if ((options.colors == null) || options.colors.length < 1) {
      options.colors = ['blue', 'orange', 'red'];
    }
    options.max = (_ref = this.attr('maxlength')) != null ? _ref : options.max;
    if (options.max === 0) {
      options.countUp = true;
    }
    jCounter = (container != null ? typeof container === 'object' ? container : $(container) : (id = (_ref1 = this.attr('id')) != null ? _ref1 : this.attr('id', "jCounterID" + (jCounterID++)).attr('id'), this.addClass('jCounterInput').wrap("<div class=\"jCounterContainer\"></div>").parent().append("<label for=\"" + id + "\" class=\"jCounter badge " + options.colors[0] + "\">" + (options.countUp ? 0 : options.max) + "</label>"), $(this).parent().children(".jCounter").css({
      borderTopRightRadius: this.css('border-top-right-radius'),
      borderBottomRightRadius: this.css('border-bottom-right-radius'),
      borderBottomLeftRadius: this.css('border-bottom-left-radius'),
      borderTopLeftRadius: this.css('border-top-left-radius')
    })));
    firstStep = options.max * (1 / options.colors.length) * 1.5;
    step = (options.max - firstStep) / (options.colors.length - 1);
    this.on('input change', throttle(function() {
      var color, index, length;
      length = _this.val().length;
      color = (options.max > 0 && options.colors.length > 0 ? length < firstStep ? options.colors[0] : (index = Math.floor((length - firstStep) / step) + 1, index < options.colors.length ? options.colors[index] : options.colors[options.colors.length - 1]) : options.colors[0]);
      jCounter.text(options.countUp ? length : options.max - length).removeClass(options.colors.join(' ')).addClass(color);
      if (container == null) {
        jCounter.css('margin-left', -(jCounter.outerWidth() + parseFloat(_this.css('border-right-width')) + parseFloat(_this.css('margin-right')) + 1));
        return _this.css('padding-right', 3 + jCounter.outerWidth());
      }
    }, 16));
    return this.trigger('change');
  };
})(jQuery);
